using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;
using DevExpress.CodeRush.Core;
using DevExpress.CodeRush.PlugInCore;
using DevExpress.CodeRush.StructuralParser;

namespace GetImplementedClasses
{
  public partial class PlugIn1 : StandardPlugIn
  {
    // DXCore-generated code...
    #region InitializePlugIn
    public override void InitializePlugIn()
    {
      base.InitializePlugIn();

      //
      // TODO: Add your initialization code here.
      //
    }
    #endregion
    #region FinalizePlugIn
    public override void FinalizePlugIn()
    {
      //
      // TODO: Add your finalization code here.
      //

      base.FinalizePlugIn();
    }
    #endregion

    public List<Class> GetImplementedClasses(Interface Interface1)
    {
      List<Class> result = new List<Class>();
      if (Interface1 != null)
      {
        ITypeElement[] descendants = Interface1.GetDescendants();
        foreach (ITypeElement descendant in descendants)
        {
          if (!descendant.InReferencedAssembly)
          {
            Class classDescendant = descendant.ToLanguageElement() as Class;
            if (classDescendant != null)
              result.Add(classDescendant);
          }
        }
      }
      return result;
    }

    private void codeProvider1_CheckAvailability(object sender, CheckContentAvailabilityEventArgs ea)
    {
      ea.Available = ea.Element is Interface && ea.Element.NameRange.Contains(ea.Caret);
    }

    private void codeProvider1_Apply(object sender, ApplyContentEventArgs ea)
    {
      Interface Interface1 = ea.Element as Interface;

      List<Class> implementedClasses = GetImplementedClasses(Interface1);

      ShowClasses(implementedClasses);
    }
    private void ShowClasses(List<Class> implementedClasses)
    {
      string msg = String.Empty;
      foreach (Class @class in implementedClasses)
        msg += @class.FullName + Environment.NewLine;
      MessageBox.Show(msg);
    }
  }
}